<html lang="en-us">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
<link rel="stylesheet" type="text/css" href="css/adu.css"/>
<style type="text/css">
.TaskGroup
{
background:white;
overflow:auto;
position:absolute;
}
/* table borders, shared by all tables */
.dataTable {
 border:1px solid #968F89;
 border-top-width:0px;
}
.dataTable td {
 background-color:#eeeeee;
 border-top:1px solid #ccc;
 vertical-align:top;
}
/* table widths */
.dataTable {
 width:100%;
}
.dataTable td {
 padding:2px 5px 1px 5px;
}
.dataTable tr td.sorted {
 background-color:#dfdfdf;
}
.dataTable tr.rowHighlight td {
 background-color:#9cf;
}
tr.altRowColor td { 
 background-color:#f5f5f5;
}
tr.captionRow th {
 background-color:#716B66;
 font-weight:bold;
 text-align:left;
 vertical-align:top;
 padding:3px 5px 2px 5px;
 color:#fff; 
 border-right:1px solid #ccc;
}
/* table links */
tr.captionRow a:link,tr.captionRow a:visited,tr.captionRow a:active,tr.captionRow a:hover ,
div.visualColumnHeader a:link,div.visualColumnHeader a:visited,div.visualColumnHeader a:active,div.visualColumnHeader a:hover {
 color:#fff;
 text-decoration:none;
}
.nestedTable { 
   color: #000000;
   border: 0px solid #968F89;    }
.nestedTable td { 
   background-color: white;    }
caption { 
   background-color:#716B66;
   font-weight:bold;
   text-align:left;
   vertical-align:top;
   padding:3px 5px 2px 5px;
   color:#fff; 
}


/*************** Ris Log ************************/
table,input,select
{
   font-family:Arial,sans-serif;
   font-size:11px;
}

h3.subTitle 
{
   background-color:#666;
   font-weight:bold;
   color:#fff;
   padding:2px 5px 2px 8px;
   margin:0px;
   font-size:100%;
   text-align:left;
}

div.subTitleBottomEdge 
{
   height:3px;
   overflow:hidden;
   background:#484848;
}	
	
/* links */
a:link, a:visited, a:active, a:hover 
{
   color: #003399;
   text-decoration:none;
}
a:hover {
   color: #003399;
   text-decoration:underline;
}

#DIV_VIEW_ID
{
   height:50px;
   background:#ccc;
}

.moreInfoLabel 
{
   background-color:#968F89;
   font-weight:bold;
   text-align:left;
   vertical-align:top;
   white-space: nowrap;
   padding:3px 5px 2px 5px;
   color:#fff;
}

.moreInfoValue 
{
	color:black;
	background-color: #EEEEEE; 
   white-space: nowrap;
	text-align:left; 
	padding: 2px 4px 2px;
}
.moreInfoValueWrap
{
	color:black;
	background-color: #EEEEEE; 
   width: auto;
	text-align:left; 
	padding: 2px 4px 2px;
}

/* alternate table row colors */
.moreInfoAltRow {
   background-color:#F5F5F5;
}

.clear
{
   clear:both;
}

.divPadding
{
   padding:10px 0 0 0;
}

.LOGViewLabel
{
   font-weight:bold;
}

.LOGView
{
   position:absolute;
   width:100%;
}

.LOGViewSettings, .LOGViewSettingsIE
{
   float:left;
   padding-top:5px;
   padding-left:8px;
}

.LOGViewSettingsIE
{
   padding-top:4px;
}

.LOGView select
{
   margin:0 5px;
}

/*************** tab ************************/

#tabs{ 
   padding:0; 
   margin:0; 
   font-family:Arial, Helvetica, sans-serif; 
   font-size:12px; 
   color:#FFF; 
   font-weight:bold; 
} 
#tabs ul{ 
   list-style:none; 
   margin:0; 
   padding:0; 
} 
#tabs ul li{ 
   display:inline; 
   margin:0; 
   text-transform:capitalize; 
} 
#tabs ul li a{ 
   background-color:#7591AC;
   color:#ffffff;
   padding:10px 10px 10px 10px;
   border-right:1px solid #fff;
   border-left:0;
} 
#tabs ul li a:hover{ 
   background:#EAEAEA; 
   color:#7F9298; 
   text-decoration:none; 
} 
#tabs ul li a.active{ 
   background-color:#ccc;
   color:#333;
   padding:10px 10px 10px 10px;
   border-right:1px solid #fff;
   border-left:0;
} 
#DIAG_CONTENT{    
   background:#ccc; 
   clear:both; 
   font-size:11px; 
   padding:10px 0px 0px 0px;
   font-family:Arial, Helvetica, sans-serif; 
} 

</style>
<script type="text/javascript" src="js/CRequestor.js"></script>
<script type="text/javascript">
var g_isMoz = false;
if(window.navigator != null && window.navigator.userAgent.indexOf("ecko") != -1)
{
   g_isMoz = true;
}

var g_sCurrentView = "DIAG_SECTION";
var g_sJSONData = "";
var g_oRisEventLogReport = null;
var SSD_GROUP_BY_CONTROLLER = 0;

function filterIcon(iconFileName, iconHeight, iconWidth, iconClass, iconID, imgExtraAttributes) {
   if (iconClass === undefined || iconClass == '') {
      iconClass = "";
   } else if (iconClass != '') {
      iconClass = "class='" + iconClass + "'";
   }
   if (iconID === undefined || iconID == '') {
      iconID = "";
   } else if (iconID != '') {
      iconID = " id='" + iconID + "'";
   }
   if (imgExtraAttributes === undefined || imgExtraAttributes == '') {
      imgExtraAttributes = "";
   } else if (imgExtraAttributes != '') {
      imgExtraAttributes = " " + imgExtraAttributes;
   }
   var imgType = iconFileName.substr(iconFileName.length - 3, 3);

   if (g_isMoz || imgType != "png") // make sure we don't filter gif's, because filtered gif's will not be animated in IE6
   {
      var iconHtml = "<img align='absmiddle' " + iconClass + iconID + " style='border:none;height:" + iconHeight + ";width:" + iconWidth + ";' src='" + iconFileName + "'" + imgExtraAttributes + "/>";
   }
   else {
      var iconHtml = "<!--[if lt IE 7]><img src='images/spacer9.gif' align='absmiddle' " + iconClass + iconID + " style=border:none;height:" + iconHeight + ";width:" + iconWidth + ";filter:progid:DXImageTransform.Microsoft.AlphaImageLoader(src='" + iconFileName + "',sizingMethod='scale');" + imgExtraAttributes + " /><![endif]--><!--[if gte IE 7]><img align='absmiddle' " + iconClass + iconID + " style='border:none;' src='" + iconFileName + "'" + imgExtraAttributes + " /><![endif]-->";
   }
   return iconHtml;
}
// parentID: TD containing img
function AddFilterToIcon(parentID, iconFileName, iconHeight, iconWidth, iconClass, iconID)
{   
   var o = document.getElementById(parentID);
   o.innerHTML = filterIcon(iconFileName, iconHeight, iconWidth, iconClass, iconID);
}

function RunReportEmbeddedJavaScript(divID)
{
   var o = document.getElementById(divID);
   var scriptObjects = o.getElementsByTagName("SCRIPT");
   for (var i = 0; i < scriptObjects.length; ++i)
   {
      eval(scriptObjects[i].innerHTML);
   }
}

function HandleOnLoad()
{
   parent.document.title = "HP Array Diagnostics and SmartSSD Wear Gauge Utility : View Diagnostic Report";

   var reportRequestor = new CRequestor();
   reportRequestor.setRequestType("ADUReportContent.js");
   reportRequestor.setEvalResult(false);
   document.getElementById("DIAG_SECTION").innerHTML = reportRequestor.executeRequest();
   RunReportEmbeddedJavaScript("DIAG_SECTION");

   var reportRequestor2 = new CRequestor();
   reportRequestor2.setRequestType("RISEventLogs.js");
   reportRequestor2.setEvalResult(false);
   g_sJSONData = eval("(" + reportRequestor2.executeRequest() + ")"); // retrieve result as a JavaScript object
   g_oRisEventLogReport = new CRisEventLogReport("DIV_VIEW_ID", "DIV_LOG_ID");
   g_oRisEventLogReport.draw();
   
   parent.footerArea.saveReportButton.onclick = function() { document.location = "ADUReport.zip" };
   parent.footerArea.ShowSaveButton();
   parent.footerArea.ShowHomeButton();
   parent.footerArea.ShowCancelButton(false);
}
function ResetADUReportSections()
{
//   g_lastVisibleSection = null;
}
function ScrollToADUReportTop()
{
   var container = document.getElementById("ADU_CONTAINER_AREA");
   container.scrollTop = 0;
}
function ScrollToADUReportDevice(sID)
{
   var elem = document.getElementById(sID);
   var reportTop = document.getElementById("ADU_CONTAINER_AREA");

   var elementOffsetTop = elem.offsetTop - ( g_isMoz ? reportTop.offsetTop : 0);
   var container = document.getElementById("ADU_CONTAINER_AREA");
   if (container)
   {
      container.scrollTop = elementOffsetTop;
   }
   else
   {
      window.scrollTo(0, elementOffsetTop);         
   }
}

function ScrollToADUReportDeviceSection(deviceID, sectionID)
{
   var elem = document.getElementById(deviceID);
   var sections = elem.getElementsByTagName("TR");
   var container = (g_isMoz ? document.getElementById("ADU_CONTAINER_AREA") : document.getElementById("ADU_CONTAINER_AREA"));
   for (var j = 0; j < sections.length; j++)
   {
      if (sections[j].className == "captionRow")
      {
         if (sections[j].id == sectionID)
         {
            container.scrollTop = elem.offsetTop + sections[j].offsetTop;
            break;
         }
      }
   }
}

// Gets element by ID.
function GE(eid)
{
   return document.getElementById(eid);
}

function getAttribute(oSmart, sID)
{
   if (typeof (oSmart) != "undefined")
   {
      for (var i = 0; i < oSmart.length; ++i)
      {
         if (typeof (oSmart[i].ID) != "undefined")
         {
            if (oSmart[i].ID == sID)
            {
               return oSmart[i].Value;
            }
         }
      }
   }
}

// Ris Event Log Report Classes
function CRisEventLogReport(sViewID, sLogID)
{
   var m_sViewContainerID = sViewID;
   var m_sViewLogID = sLogID;
   var m_sViewID = sViewID + "_BUTTONS";
   this.m_oCtrlContainer = new CCtrlContainer();
   var m_oView = new CCtrlView(this, m_sViewID, this.m_oCtrlContainer);
   var m_isAlt = 0; // alternate the rows light/dark/light/dark, etc.
   var m_sAltClass = " moreInfoAltRow";

   this.draw = function()
   {
      var s = '';
      var oMPL = g_sJSONData.RISData.MetaPropertyList;

      // View Container.
      s += '<table width="100%" cellpadding="0" cellspacing="0"><tr><td>';
      s += '<div id="' + m_sViewContainerID + '">';
      s += '<table width="100%" cellpadding="0" cellspacing="0" bgcolor="#666666"><tr><td><h3 class="subTitle">Controller Event Logs</h3></td>';
      s += '<td align="right" style="color:#ffffff;padding-right:5px">Time Generated: ' + getAttribute(oMPL, "Time Generated") + '</td></tr></table>';
      s += '<div class="subTitleBottomEdge"></div>';
      s += '<div id="' + m_sViewID + '" class="LOGView"></div>';
      s += '</div></td></tr>';

      // Log
      s += '<tr><td><div id="' + m_sViewLogID + '">';
      s += '</div></td></tr></table>';

      GE("LOG_SECTION").innerHTML = s;

      m_oView.draw();
      this.DrawLogs(0);
   }

   this.updateControllerChange = function(sVal)
   {
      this.DrawLogs(sVal);
   }

   // Toggles the shade of the cell to be displayed next in a table and 
   // returns which shade to be used now.
   this.getAlt = function()
   {
      var sAltClass = m_isAlt ? m_sAltClass : "";
      m_isAlt = !m_isAlt;
      return sAltClass;
   }

   this.resetAlt = function()
   {
      m_isAlt = 0;
   }

   this.DisplayLogHeader = function()
   {
      var s = '<tr>';
      s += '<td class="moreInfoLabel">Event ID</td><td class="moreInfoLabel">Timestamp</td>'
            + '<td class="moreInfoLabel">Class</td><td class="moreInfoLabel">Subclass</td>'
            + '<td class="moreInfoLabel">Summary</td><td class="moreInfoLabel">Detail</td>';
      s += '</tr>';
      return s;
   }

   // Displays log for a ctroller.
   this.DrawLogs = function(sVal)
   {
      this.resetAlt();
      var s = "";

      var nCtrl = Math.floor(parseInt(sVal) / 100);
      var nLog = parseInt(sVal) % 100;

      var aCtrls = this.m_oCtrlContainer.getCtrls();
      if (aCtrls.length != 0)
      {

         var aEventLogs = this.m_oCtrlContainer.getCtrollerLog(nCtrl);

         if (aEventLogs)
         {
            s += '<table width="100%"><tr><td class="moreInfoLabel" width="50px">Devices: </td><td class="moreInfoValueWrap moreInfoAltRow">' + aEventLogs[nLog].Devices + '</td>';
            s += '<td class="moreInfoLabel" align="right" width="110px">Number of Events: </td><td class="moreInfoValue moreInfoAltRow" align="right"  width="25px">' + aEventLogs[nLog].NumEvents + '</td></tr></table>';

            var aEvents = aEventLogs[nLog].Events;
            s += "<table>";
            s += this.DisplayLogHeader();
            for (var i = 0; i < aEvents.length; i++)
            {
               var sRowColor = this.getAlt();
               s += '<tr>' +
                  '<td class="moreInfoValue' + sRowColor + '">' + aEvents[i].ID +
                  '</td><td class="moreInfoValue' + sRowColor + '">' + aEvents[i].Timestamp +
                  '</td><td class="moreInfoValue' + sRowColor + '">' + aEvents[i].Class +
                  '</td><td class="moreInfoValue' + sRowColor + '">' + aEvents[i].Subclass +
                  '</td><td class="moreInfoValue' + sRowColor + '">' + aEvents[i].Summary +
                  '</td><td class="moreInfoValueWrap' + sRowColor + '">' + aEvents[i].Detail +
                  '</td></tr>';
            }
            s += "</table>";
         }
         else
         {
            s = "<br><h3>The selected controller does not contain a valid RIS event log. The controller has no physical drives attached, is not configured, or the RIS event log is not compatible with this utility.</h3>";
         }
      }

      var o = GE(m_sViewLogID);
      o.innerHTML = s;
   }
}

function CCtrlContainer()
{
   var m_oCtrls;

   this.Destructor = function()
   {
      if (m_oCtrls != null)
      {
         for (var i = 0; i < m_oCtrls.length; ++i)
         {
            m_oCtrls[i] = null;
         }
         m_oCtrls = null;
      }
   }

   this.getCtrls = function()
   {
      return m_oCtrls;
   }

   this.getCtrollerName = function(index)
   {
      return m_oCtrls[index].Name;
   }

   this.getCtrollerLog = function(index)
   {
      return m_oCtrls[index].EventLogs;
   }

   this.Constructor = function()
   {
      m_oCtrls = g_sJSONData.RISData.ControllerList;
   }

   this.Constructor();
}

// Contains controls for managing the view and layout of the device tree.
function CCtrlView(oParent, sViewID, oCtrlContainer)
{
   var m_sViewID = sViewID;
   var m_oCtrlContainer = oCtrlContainer;
   var m_sControllerSelectorID = "dropdownControllers";
   var m_oControllerDOMElement;
   this.m_oParent = oParent;
   var m_sControllerIndex = 0;
   var m_sViewSettingsClass = g_isMoz ? "LOGViewSettings" : "LOGViewSettingsIE";

   function getOption(sVal, sLabel, sCurrentVal)
   {
      var sHTML = "<option ";
      if (sVal == sCurrentVal)
      {
         sHTML += "selected ";
      }
      sHTML += "value='" + sVal + "'>";
      sHTML += sLabel + "</option>";
      return sHTML;
   }

   this.draw = function()
   {
      var aCtrls = oCtrlContainer.getCtrls();
      if (aCtrls.length != 0)
      {

         var sHTML = "<div class=\"" + m_sViewSettingsClass + "\">";
         sHTML += "<span class='LOGViewLabel'>Select a Controller</span>";
         sHTML += "<select id='" + m_sControllerSelectorID + "'>";

         for (var i = 0; i < aCtrls.length; i++)
         {
            var aEventLogs = m_oCtrlContainer.getCtrollerLog(i);

            if (aEventLogs)
            {
               // Loop through aEventLogs
               for (var j = 0; j < aEventLogs.length; j++)
               {
                  sHTML += getOption(i * 100 + j, m_oCtrlContainer.getCtrollerName(i) + " - Event Log " + (j + 1), m_sControllerIndex);
               }
            }
            else
            {
               sHTML += getOption(i * 100, m_oCtrlContainer.getCtrollerName(i), m_sControllerIndex);
            }
         }
         sHTML += "</select>";
         sHTML += "</div><div class=\"clear\"></div>";
         var o = GE(m_sViewID);
         if (o)
         {
            o.innerHTML = sHTML;
         }

         this.InitPost();
      }
      else
      {
         var sHTML = "<div class=\"" + m_sViewSettingsClass + "\">";
         sHTML += "<span class='LOGViewLabel'>No controller contains RIS event logs.</span></div>";
         var o = GE(m_sViewID);
         if (o)
         {
            o.innerHTML = sHTML;
         }
      }
   }

   this.updateControllerChange = function(oParent)
   {
      var oOpt = GE(m_sControllerSelectorID);
      if (oOpt)
      {
         m_sControllerIndex = oOpt.value;
         oParent.updateControllerChange(m_sControllerIndex);
      }
   }

   this.InitPost = function()
   {
      m_oControllerDOMElement = GE(m_sControllerSelectorID);
      m_oControllerDOMElement.onchange = CCtrlView.onChangeController(this);
   }
}

CCtrlView.onChangeController = function(oCtrlView)
{
   return (function(e)
   {
      oCtrlView.updateControllerChange(oCtrlView.m_oParent);
   });
}

function ToggleView(nView)
{
   var oDIAG_SECTION = GE("DIAG_SECTION");
   var oLOG_SECTION = GE("LOG_SECTION");
   var oTAB_DIAG = GE("TAB_DIAG");
   var oTAB_LOG = GE("TAB_LOG");
   if (nView == 1)
   {
      oLOG_SECTION.style.display = "none";
      oDIAG_SECTION.style.display = "block";
      oTAB_DIAG.className = "active";
      oTAB_LOG.className = "";
   }
   else
   {
      oDIAG_SECTION.style.display = "none";
      oLOG_SECTION.style.display = "block";
      oTAB_DIAG.className = "";
      oTAB_LOG.className = "active";
   }
}

</script>
</head>
<body onload="HandleOnLoad();">
<div id="ADU_CONTAINER_AREA" style="width:100%;height:100%;position:absolute;overflow:auto;">
   <div id='tabs'> 
      <ul> 
         <li><a href="#" id="TAB_DIAG" class="active" onclick="ToggleView(1);">Diagnostic Report</a></li> 
         <li><a href="#" id="TAB_LOG" onclick="ToggleView(2);">RIS Event Log</a></li> 
      </ul> 
   </div> 
   <div id="DIAG_CONTENT" class="TaskGroup">
      <div id="DIAG_SECTION"></div>
      <div id="LOG_SECTION" style="display:none;"></div>
   </div>
</div>
</body>
</html>