<html lang="en-us">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
<link rel="stylesheet" type="text/css" href="css/adu.css"/>
<style type="text/css">
.TaskGroup
{
background:white;
overflow:auto;
position:absolute;
}
/* table borders, shared by all tables */
.dataTable {
 border:1px solid #968F89;
 border-top-width:0px;
}
.dataTable td {
 background-color:#eeeeee;
 border-top:1px solid #ccc;
 vertical-align:top;
}
/* table widths */
.dataTable {
 width:100%;
}
.dataTable td {
 padding:2px 5px 1px 5px;
}
.dataTable tr td.sorted {
 background-color:#dfdfdf;
}
.dataTable tr.rowHighlight td {
 background-color:#9cf;
}
tr.altRowColor td { 
 background-color:#f5f5f5;
}
tr.captionRow th {
 background-color:#716B66;
 font-weight:bold;
 text-align:left;
 vertical-align:top;
 padding:3px 5px 2px 5px;
 color:#fff; 
 border-right:1px solid #ccc;
}
/* table links */
tr.captionRow a:link,tr.captionRow a:visited,tr.captionRow a:active,tr.captionRow a:hover ,
div.visualColumnHeader a:link,div.visualColumnHeader a:visited,div.visualColumnHeader a:active,div.visualColumnHeader a:hover {
 color:#fff;
 text-decoration:none;
}
.nestedTable { 
   color: #000000;
   border: 0px solid #968F89;    }
.nestedTable td { 
   background-color: white;    }
caption { 
   background-color:#716B66;
   font-weight:bold;
   text-align:left;
   vertical-align:top;
   padding:3px 5px 2px 5px;
   color:#fff; 
}

</style>
<script type="text/javascript" src="js/CRequestor.js"></script>
<script type="text/javascript">
var g_isMoz = false;
if(window.navigator != null && window.navigator.userAgent.indexOf("ecko") != -1)
{
   g_isMoz = true;
}

function HandleOnLoad()
{
   parent.parent.document.title = "HP Array Diagnostics and SmartSSD Wear Gauge Utility : View Diagnostic Report";   

   var reportRequestor = new CRequestor();
   reportRequestor.setRequestType("ADUReportContent.js");
   reportRequestor.setEvalResult(false);
   document.getElementById("DIAG_CONTENT").innerHTML = reportRequestor.executeRequest();   
}
function ResetADUReportSections()
{
//   g_lastVisibleSection = null;
}
function ScrollToADUReportTop()
{
   var container = document.getElementById("DIAG_CONTENT");
   container.scrollTop = 0;
}
function ScrollToADUReportDevice(sID)
{
   var elem = document.getElementById(sID);
   var reportTop = document.getElementById("DIAG_CONTENT");

   var elementOffsetTop = elem.offsetTop - ( g_isMoz ? reportTop.offsetTop : 0);
   var container = document.getElementById("DIAG_CONTENT"); 
   if (container)
   {
      container.scrollTop = elementOffsetTop;
   }
   else
   {
      window.scrollTo(0, elementOffsetTop);         
   }
}

function ScrollToADUReportDeviceSection(deviceID, sectionID)
{
   var elem = document.getElementById(deviceID);
   var sections = elem.getElementsByTagName("TR");
   var container = (g_isMoz ? document.getElementById("DIAG_CONTENT") : document.getElementById("DIAG_CONTENT"));
   for (var j = 0; j < sections.length; j++)
   {
      if (sections[j].className == "captionRow")
      {
         if (sections[j].id == sectionID)
         {
            container.scrollTop = elem.offsetTop + sections[j].offsetTop;
            break;
         }
      }
   }
}

</script>
</head>
<body onload="HandleOnLoad();">
<div id="ADU_CONTAINER_AREA" style="width:100%;height:100%;position:absolute;overflow:auto;">
<div id="DIAG_CONTENT" class="TaskGroup" style="width:100%;height:100%;"></div>
</div>
</body>
</html>